Bug 1009330 - saved_entry doesn't match any title or id in grub.cfg
saved_entry doesn't match any title or id in grub.cfg
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: grubby (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Peter Jones
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-18 04:41 EDT by Matthew Booth
Modified: 2015-02-17 12:13 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 12:13:56 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Matthew Booth 2013-09-18 04:41:59 EDT
Description of problem:
On my fully updated workstation:

/boot/grub2/grubenv contains:
saved_entry=Fedora Linux, with Linux 3.8.11-200.fc18.x86_64

/boot/grub2/grub.cfg contains:
set default="0"

menuentry 'Fedora (3.10.11-200.fc19.x86_64) 19 (Schrödinger’s Cat)' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-simple-8e627206-ede8-4abd-b599-f6a214bf3200' {

menuentry 'Fedora (3.10.10-200.fc19.x86_64) 19 (Schrödinger’s Cat)' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-simple-8e627206-ede8-4abd-b599-f6a214bf3200' {

menuentry 'Fedora (3.10.9-200.fc19.x86_64) 19 (Schrödinger’s Cat)' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-simple-8e627206-ede8-4abd-b599-f6a214bf3200' {

menuentry 'Fedora 19 Rescue b74a4273c1b54b5e8fa412e4c04978e8 (3.9.4-300.fc19.x86_64)' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-simple-8e627206-ede8-4abd-b599-f6a214bf3200' {


On a freshly installed Fedora 19 GA guest:
/boot/grub2/grubenv contains:
saved_entry=Fedora Linux, with Linux 3.9.5-301.fc19.x86_64

/boot/grub2/grub.cfg contains:
   set default="${saved_entry}"

menuentry 'Fedora, with Linux 3.9.5-301.fc19.x86_64' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-3.9.5-301.fc19.x86_64-advanced-3df40e11-555d-4227-b45f-ba551b2f4fa6' {

menuentry 'Fedora, with Linux 0-rescue-d038cede98b74b7192266d40924cca79' --class fedora --class gnu-linux --class gnu --class os $menuentry_id_option 'gnulinux-0-rescue-d038cede98b74b7192266d40924cca79-advanced-3df40e11-555d-4227-b45f-ba551b2f4fa6' {


Note that in no case do the contents of grubenv and grub.cfg align, although note that on the fully updated workstation, grub.cfg doesn't reference saved_entry (I will file a separate bug about this). In this case the configuration is merely misleading. On the fresh install it does reference saved_entry, meaning the configuration is incorrect.

Version-Release number of selected component (if applicable):
grubby-8.28-1.fc19.x86_64 (fully updated)
grubby-8.26-2.fc19.x86_64 (GA fresh install)
Comment 1 Matthew Booth 2013-09-18 05:04:52 EDT
I was investigating to file a bug about the replacement of set default= in grub.cfg, and I've noticed that this seems to have been fixed. It seems that some old version of grubby would replace set default= in grub.cfg. Newer grubby seems to recognise this and not update grubenv. If I install a F19 GA image with non-broken grub.cfg, update grubby *before* installing any new kernel, then install a new kernel, I get the desired behaviour. Namely:

* grub.cfg remains non-broken
* saved_entry references a valid title in grub.cfg

This is still unfortunate for anybody who ever installed a new kernel with the older grubby. I was going to close this out, but I think it's worth leaving open because the problem of legacy broken configurations remains.

It seems to me that the following procedure would fix it:
* Fully update grubby
* Replace grub.cfg with the output of grub2-mkconfig
* Install a new kernel

I don't think this is worth fixing in F19 if it will be fixed automatically when a system is upgraded to F20. However, if a F20 upgrade doesn't rewrite grub.cfg from scratch, then I think a packaging fix in grubby is required. Otherwise systems will be carrying a broken grub.cfg indefinitely due to a long-expired bug.
Comment 2 Fedora End Of Life 2015-01-09 14:52:52 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2015-02-17 12:13:56 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.